package dmLab.utils;

/**
 * <p>Title: Class that contains math functions</p>
 * <p>Description: couple of mathematical functions</p>
 * <p>Copyright: Copyright (c) 2003-2004</p>
 * <p>Company: Institute of Computer Science, Polish Academy of  Sciences</p>
 * @author Michal Draminski
 * @version 1.0
 */


public class MyMath
{
  public MyMath()
  {
  }
//***************************************************
/**
 * calculates any logarithm
 * @param x
 * @param a
 * @return
 */
  public static double log(double x,double a)
  {
    return Math.log(x)/Math.log(a);
  }
//***************************************************
  public static double log2(double x)
  {
    return Math.log(x)/Math.log(2);
  }
//***************************************************
/**
 * calculates average
 * @param array
 * @return
 */
 public static double avg(float array[])
 {
     double avg=0;
     for(int i=0;i<array.length;i++)
         avg+=array[i];
     return avg/(double)array.length;
 }
//***********************************
 public static double stdev(float array[])
 {
     return Math.sqrt(var(array));
 }
//***********************************
 public static double var(float array[])
 {
     if(array.length<=1)
         return 0.0;
     
     double avg=avg(array);     
     double sum = 0;
     for (int i = 0; i < array.length; i++)
     {
         sum += Math.pow(array[i]-avg,2.0);
     }
     sum=sum/(double)(array.length-1.0);    
     return sum;
 }
//***********************************

 /**
  * static method for entropy calculation
  * @param array double[] input values
  * @param normalize boolean if return value has to be normalized
  * @return double entropy
  */
 public static double entropy(double array[],boolean normalize)
{
  if(array.length==1)
    return 0;
  double entrophy=0;
  double sum=0;

  for(int i=0;i<array.length;i++)
    sum+=array[i];
  for(int i=0;i<array.length;i++)
  {
    double temp=((double)array[i]/sum);
    if( temp >0)
      entrophy -= temp * MyMath.log2(temp);
  }
  if(normalize)
    entrophy=entrophy/MyMath.log2(array.length);
  return entrophy;
}
//***********************************
public static double newton(double n, double k)
{
  double newton=1;
  double nominator=n-k;
  double denominator=1;
  for(int i=0;i<k;i++)
  {
    newton*=n--/k--;
  }
  return newton;
}
//***************************************************
  public static void test()
  {
    //double[] x = {100,1,1,1,1,1,1,1,1,1,1,1};
/*    double[] x = {1,2,3,5};
    System.out.println("x:" + MyMath.entropy(x,true));
    System.out.println("x:" + MyMath.avg(x));
    System.out.println("x:" + MyMath.stdevp(x));
*/
  System.out.println(newton(4000,200));
  }
//***************************************************
}
